# document folding datas layer

require 'FoldDocument'

class BasicFoldDocument < FoldDocument
  
  def initialize( lineCount = 0 )
    @lines = Array.new( 0 )
    self.lineCount = lineCount
  end
  
  # core functions:
  # ---------------
  
  def setFoldLevel( lineNumber, level )
    return if lineNumber >= lineCount
    @lines[ lineNumber ].level = level
  end
  
  # valid flag: either :foldPoint or :blank
  def setFoldFlag( lineNumber, flag )
    return if lineNumber >= lineCount
    @lines[ lineNumber ].flag = flag
  end
  
  def foldLevel( lineNumber )
    return 0 if lineNumber >= lineCount
    @lines[ lineNumber ].level
  end
  
  def foldFlag( lineNumber )
    return NONE if lineNumber >= lineCount
    @lines[ lineNumber ].flag
  end
  
  def lineCount()
    @lines.length
  end
  
  def lineCount=( lineNumber )
    while @lines.length < lineNumber
      @lines << @@lineData.new( 0, NONE )
    end
    @lines.slice!( lineNumber, @lines.length )
  end

  private
  
  @@lineData = Struct.new( 'LineData', :level, :flag )
  
end


