require 'scintilla/ScConstant.rb'

class BraceHighlighter
	def initialize( sourceDocument )
		@source = sourceDocument
		@editControl = @source.editControl()
	end

	def highlightBraces()
    braceFound = false
    currentPosition = @editControl.currentPos();
		if currentPosition < @editControl.textLength()
			braceFound = braceFound || tryHighlightBraceAt( currentPosition, '([{' )
		end
		if currentPosition > 0
			braceFound = braceFound || tryHighlightBraceAt( currentPosition-1, ')]}' )
		end
		hideBracesHighlight() unless braceFound
  end

  def tryHighlightBraceAt( position, braces )
    character = @editControl.textRange( position, position+1 )
		if braces.rindex( character ) == nil  or !operatorStyle?( @editControl.styleAt(position) )
			return false
		end

    oppositeBracePosition = @editControl.braceMatch( position )
    if oppositeBracePosition == Scintilla::Constant::INVALID_POSITION
			@editControl.braceBadLight( position )
		else
			@editControl.braceHighlight( position, oppositeBracePosition )
		end
		true
  end

  def hideBracesHighlight
    @editControl.braceHighlight( Scintilla::Constant::INVALID_POSITION, 
		                             Scintilla::Constant::INVALID_POSITION )
  end

  def operatorStyle?( style )
    style == Scintilla::Constant::SCE_P_OPERATOR
  end
	
end
