# document folding datas layer

class FoldDocument
  
  NONE = nil
  FOLD_POINT = :foldPoint
  BLANK_LINE = :blank
  
  # core functions:
  # ---------------
  
  def setFoldLevel( lineNumber, level )
  end
  
  # valid flag: either :foldPoint or :blank
  def setFoldFlag( lineNumber, flag = NONE )
  end
  
  def foldLevel( lineNumber )
  end
  
  def foldFlag( lineNumber )
  end
  
  def lineCount()
  end

  # additional functions:
  # ---------------------
  
  def foldPoint?( lineNumber )
    foldFlag(lineNumber) == :foldPoint
  end

  def blankLine?( lineNumber )
    foldFlag(lineNumber) == :blank
  end
  
  def setFoldLevelAndFlag( lineNumber, level, flag )
    setFoldLevel( lineNumber, level )
    setFoldFlag( lineNumber, flag )
  end
  
  def findFoldPointLineFor( lineNumber )
    lineNumber = lineCount-1 if lineNumber >= lineCount
    return -1 if lineNumber < 0
    return lineNumber if foldPoint?( lineNumber )
      
    startingLevel = foldLevel( lineNumber )
    while lineNumber >= 0
      return lineNumber if foldPoint?( lineNumber )  &&  
                           foldLevel( lineNumber ) < startingLevel
      lineNumber -= 1
    end
    return -1
  end
  
  def findFoldPointRange( lineNumber )
    return nil if lineNumber < 0  ||  
                  lineNumber >= lineCount  || 
                  !foldPoint?( lineNumber )
    startingLine = lineNumber
    startingLevel = foldLevel( startingLine )
    lineNumber += 1
    maxLineNumber = lineCount-1
    while lineNumber <= maxLineNumber  &&  foldLevel( lineNumber ) > startingLevel
      lineNumber += 1
    end
    endingLine = lineNumber-1
    return startingLine..endingLine
  end
end


