
class Logger
  DEBUG = false
  @@output = $stderr
  
  def Logger.output=( output )
    @@output = output ? output : $stderr
  end
  
  def Logger.outputToFile( directory, name, datedName )
    return unless DEBUG
    fileName = directory + "/" + name
    if datedName
      t = Time.now
      fileName += "-%d%02d%02d-%02dh%02dm%02ds" % [t.year,t.month,t.day,t.hour,t.min,t.sec]
    end
    fileName += '.log'
    @@output = File.open( fileName, 'w' )
  end
  
  def Logger.print( text )
    return unless DEBUG
    @@output.print text
    @@output.flush
  end
  
  def Logger.puts( text )
    return unless DEBUG
    @@output.puts text
    @@output.flush
  end
  
end



