#Observer Pattern

module Observable
	
	def addListener( eventType, &listener )
		@listeners = {} unless @listeners
		eventTypeListeners = @listeners[eventType]
		if eventTypeListeners
			eventTypeListeners  << listener
		else
			@listeners[eventType] = [listener]
		end
		listener
	end
	
	def removeListener( eventType, listener )
		if @listeners
			eventTypeListeners = @listeners[eventType]
			eventTypeListeners.delete( listener ) if eventTypeListeners
		end
		listener
	end
	
	protected
	def signalEvent( eventType, *parameters )
		if @listeners
			eventTypeListeners = @listeners[eventType]
			eventTypeListeners.each { |listener| listener.call( *parameters ) } if eventTypeListeners
		end
	end
	
end



