#unit test for BasicFoldDocument

require 'test/unit'
require 'BasicFoldDocument'


class TestBasicFoldDocument < Test::Unit::TestCase
	def set_up
    @folders = BasicFoldDocument.new()
	end
	
	def tear_down
    @folders = nil
	end
	
	def testConstructor
		assert_equal( 0, @folders.lineCount )
    badLineNumber = 0
    assert_equal( 0, @folders.foldLevel( badLineNumber ) )
    assert_equal( FoldDocument::NONE, @folders.foldFlag( badLineNumber ) )
	end
  
  def testSetFoldLevel
    @folders.lineCount = 1
    @folders.setFoldLevel( 0, 7 )
    
    assert_equal( 1, @folders.lineCount )
    assert_equal( 7, @folders.foldLevel(0) )
    assert_equal( FoldDocument::NONE, @folders.foldFlag(0) )
  end
  
  def testSetFoldPoint
    @folders.lineCount = 1
    @folders.setFoldFlag( 0, FoldDocument::FOLD_POINT )

    assert_equal( 1, @folders.lineCount )
    assert_equal( FoldDocument::FOLD_POINT, @folders.foldFlag(0) )
  end
    
  def testSetBlankLine
    @folders.lineCount = 1
    @folders.setFoldFlag( 0, FoldDocument::BLANK_LINE )

    assert_equal( 1, @folders.lineCount )
    assert_equal( FoldDocument::BLANK_LINE, @folders.foldFlag(0) )
  end
    
  def testSetNone
    @folders.lineCount = 1
    @folders.setFoldFlag( 0, FoldDocument::NONE )

    assert_equal( 1, @folders.lineCount )
    assert_equal( FoldDocument::NONE, @folders.foldFlag(0) )
  end
  
  def testSetFoldLevelManyLines
    @folders.lineCount = 3
    @folders.setFoldLevel( 2, 9 )
    
    assert_equal( 3, @folders.lineCount )
    assert_equal( 0, @folders.foldLevel(0) )
    assert_equal( 0, @folders.foldLevel(1) )
    assert_equal( 9, @folders.foldLevel(2) )
  end
  
  def testSetFoldFlagManyLines
    @folders.lineCount = 2
    @folders.setFoldFlag( 1, FoldDocument::FOLD_POINT )
    
    assert_equal( 2, @folders.lineCount )
    assert_equal( FoldDocument::NONE, @folders.foldFlag(0) )
    assert_equal( FoldDocument::FOLD_POINT, @folders.foldFlag(1) )
	end
  
  def testSetFoldLevelAndFlag
    @folders.lineCount = 5
    @folders.setFoldFlag( 1, FoldDocument::BLANK_LINE )
    @folders.setFoldLevel( 2, 7 )
    @folders.setFoldFlag( 2, FoldDocument::FOLD_POINT )
    @folders.setFoldFlag( 4, FoldDocument::FOLD_POINT )
    @folders.setFoldLevel( 4, 5 )
    
    assert_equal( 5, @folders.lineCount )
    assert_equal( 0, @folders.foldLevel(0) )
    assert_equal( FoldDocument::NONE, @folders.foldFlag(0) )
    assert_equal( 0, @folders.foldLevel(1) )
    assert_equal( FoldDocument::BLANK_LINE, @folders.foldFlag(1) )
    assert_equal( 7, @folders.foldLevel(2) )
    assert_equal( FoldDocument::FOLD_POINT, @folders.foldFlag(2) )
    assert_equal( 0, @folders.foldLevel(3) )
    assert_equal( FoldDocument::NONE, @folders.foldFlag(3) )
    assert_equal( 5, @folders.foldLevel(4) )
    assert_equal( FoldDocument::FOLD_POINT, @folders.foldFlag(4) )
  end
  
end


