require 'scintilla/ScConstant.rb'

module Scintilla

	class Modifiers
		attr_writer :shiftPressed, :controlPressed, :alternatePressed
		
		def initialize( flags )
			@shiftPressed = (flags & Scintilla::Constant::SCMOD_SHIFT) != 0
			@controlPressed = (flags & Scintilla::Constant::SCMOD_CTRL) != 0
			@alternatePressed = (flags & Scintilla::Constant::SCMOD_ALT) != 0
		end
		
		def shiftPressed?()
			@shiftPressed
		end
		
		def controlPressed?()
			@controlPressed
		end
		
		def alternatePressed?()
			@alternatePressed
		end
		
		def to_i()
			flag = 0
			flag |= Scintilla::Constant::SCMOD_SHIFT if @shiftPressed
			flag |= Scintilla::Constant::SCMOD_CTRL if @controlPressed
			flag |= Scintilla::Constant::SCMOD_ALT if @alternatePressed
			flag
		end
		
		def to_s()
			'<Keys:' + ( @shiftPressed ? ' SHIFT' : '' ) + 
								 ( @controlPressed ? ' CTRL' : '' ) + 
								 ( @alternatePressed ? ' ALT' : '' ) + ' >'
		end
	end
	
end
